var lib = new Global("lib");

/* 
 * there doesn't seem to be a better way to check if the property of Global is
 * initialized. This check allows to have multiple master objects - e.g. one per 
 * patch.
 */
if (!lib.slaves instanceof Array) spread_reset();

function spread_reset() { lib.slaves = []; }

lib.add_slave = function( obj ) { 
  lib.slaves.push( obj ); 
  // see js_valid() below
  obj._box = obj.box;
}

/* 
 * this is based on the bug (feature?) in max javascript: when the patch
 * containing a [js] object is closed the object's box property starts to point
 * to some random object. So we store the original box in _box property and
 * compare them here. (Another bug: the stored _box remains valid after the patch 
 * is closed, otherwise we could use that property).
 */
js_valid.local = 1;
function js_valid( obj ) {
  return obj._box == obj.box;
}

function anything() {
  var a = arrayfromargs(arguments);

  lib.slaves = lib.slaves.filter( js_valid );

  for(var i in lib.slaves) {
    var s = lib.slaves[i];
    if (s[messagename] instanceof Function)
      s[messagename].apply(s,arguments);
  }
}

autowatch = 1;
